diff --git a/contrib/amd/amd/srvr_nfs.c b/contrib/amd/amd/srvr_nfs.c
index 93b4c8e..0c74a65 100644
--- a/contrib/amd/amd/srvr_nfs.c
+++ b/contrib/amd/amd/srvr_nfs.c
@@ -828,29 +1005,32 @@ find_nfs_srvr(mntfs *mf)
     mf->mf_flags |= MFF_ERROR;
     mf->mf_error = ENOENT;
   }
+  if (mf->mf_flags & MFF_WEBNFS)
+    fs->fs_flags |= FSF_WEBNFS;
   fs->fs_version = nfs_version;
   fs->fs_proto = nfs_proto;
   fs->fs_type = MNTTAB_TYPE_NFS;
   fs->fs_pinger = AM_PINGER;
+  fs->fs_flags |= FSF_PING_UNINIT; /* pinger hasn't been initialized */
   np = ALLOC(struct nfs_private);
   memset((voidp) np, 0, sizeof(*np));
   np->np_mountd_inval = TRUE;
-  np->np_xid = NPXID_ALLOC(struct );
+  np->np_xid = XID_ALLOC();
   np->np_error = -1;
 
   /*
    * Initially the server will be deemed dead after
    * MAX_ALLOWED_PINGS of the fast variety have failed.
    */
-  np->np_ttl = clocktime() + MAX_ALLOWED_PINGS * FAST_NFS_PING - 1;
+  np->np_ttl = clocktime(NULL) + MAX_ALLOWED_PINGS * FAST_NFS_PING - 1;
   fs->fs_private = (voidp) np;
   fs->fs_prfree = (void (*)(voidp)) free;
 
-  if (!(fs->fs_flags & FSF_ERROR)) {
-    /*
-     * Start of keepalive timer
-     */
+  if (!FSRV_ERROR(fs)) {
+    /* start of keepalive timer, first updating pingval */
     start_nfs_pings(fs, pingval);
+    if (fserver_is_down)
+      fs->fs_flags |= FSF_VALID | FSF_DOWN;
   }
 
   /*
diff --git a/contrib/amd/amq/amq.c b/contrib/amd/amq/amq.c
index 4d90a93..2379b62 100644
--- a/contrib/amd/amq/amq.c
+++ b/contrib/amd/amq/amq.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,11 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: amq.c,v 1.6 1999/09/08 23:36:40 ezk Exp $
- * $FreeBSD: src/contrib/amd/amq/amq.c,v 1.5 1999/09/15 05:45:14 obrien Exp $
- * $DragonFly: src/contrib/amd/amq/amq.c,v 1.3 2004/01/23 19:49:35 joerg Exp $
+ * File: am-utils/amq/amq.c
  *
  */
 
@@ -48,19 +45,6 @@
  * Automounter query tool
  */
 
-#ifndef lint
-char copyright[] = "\
-@(#)Copyright (c) 1997-1999 Erez Zadok\n\
-@(#)Copyright (c) 1990 Jan-Simon Pendry\n\
-@(#)Copyright (c) 1990 Imperial College of Science, Technology & Medicine\n\
-@(#)Copyright (c) 1990 The Regents of the University of California.\n\
-@(#)All rights reserved.\n";
-#if __GNUC__ < 2
-static char rcsid[] = "$Id: amq.c,v 1.6 1999/09/08 23:36:40 ezk Exp $";
-static char sccsid[] = "%W% (Berkeley) %G%";
-#endif /* __GNUC__ < 2 */
-#endif /* not lint */
-
 #ifdef HAVE_CONFIG_H
 # include <config.h>
 #endif /* HAVE_CONFIG_H */
@@ -76,9 +60,9 @@ static int stats_flag;
 static int getvers_flag;
 static int amd_program_number = AMQ_PROGRAM;
 static int use_tcp_flag, use_udp_flag;
+static int getpwd_flag;
 static char *debug_opts;
 static char *amq_logfile;
-static char *mount_map;
 static char *xlog_optstr;
 static char localhost[] = "localhost";
 static char *def_server = localhost;
@@ -87,14 +71,6 @@ static char *def_server = localhost;
 extern int optind;
 extern char *optarg;
 
-/* forward declarations */
-#ifdef HAVE_TRANSPORT_TYPE_TLI
-static CLIENT *get_secure_amd_client(char *host, struct timeval *tv, int *sock);
-static int amq_bind_resv_port(int td, u_short *pp);
-#else /* not HAVE_TRANSPORT_TYPE_TLI */
-static int privsock(int ty);
-#endif /* not HAVE_TRANSPORT_TYPE_TLI */
-
 /* structures */
 enum show_opt {
   Full, Stats, Calc, Short, ShowDone
@@ -125,8 +101,8 @@ show_mti(amq_mount_tree *mt, enum show_opt e, int *mwid, int *dwid, int *twid)
 
   case Full:
     {
-      struct tm *tp = localtime((time_t *) &mt->mt_mounttime);
-      printf("%-*.*s %-*.*s %-*.*s %s\n\t%-5d %-7d %-6d %-7d %-7d %-6d %02d/%02d/%02d %02d:%02d:%02d\n",
+      struct tm *tp = localtime((time_t *) ((voidp) &mt->mt_mounttime));
+      printf("%-*.*s %-*.*s %-*.*s %s\n\t%-5d %-7d %-6d %-7d %-7d %-6d %02d/%02d/%04d %02d:%02d:%02d\n",
 	     *dwid, *dwid,
 	     *mt->mt_directory ? mt->mt_directory : "/",	/* XXX */
 	     *twid, *twid,
@@ -142,16 +118,16 @@ show_mti(amq_mount_tree *mt, enum show_opt e, int *mwid, int *dwid, int *twid)
 	     mt->mt_readlink,
 	     mt->mt_statfs,
 
-	     tp->tm_year > 99 ? tp->tm_year - 100 : tp->tm_year,
 	     tp->tm_mon + 1, tp->tm_mday,
+	     tp->tm_year < 1900 ? tp->tm_year + 1900 : tp->tm_year,
 	     tp->tm_hour, tp->tm_min, tp->tm_sec);
     }
   break;
 
   case Stats:
     {
-      struct tm *tp = localtime((time_t *) &mt->mt_mounttime);
-      printf("%-*.*s %-5d %-7d %-6d %-7d %-7d %-6d %02d/%02d/%02d %02d:%02d:%02d\n",
+      struct tm *tp = localtime((time_t *) ((voidp) &mt->mt_mounttime));
+      printf("%-*.*s %-5d %-7d %-6d %-7d %-7d %-6d %02d/%02d/%02d %02d:%02d:%04d\n",
 	     *dwid, *dwid,
 	     *mt->mt_directory ? mt->mt_directory : "/",	/* XXX */
 
@@ -162,8 +138,8 @@ show_mti(amq_mount_tree *mt, enum show_opt e, int *mwid, int *dwid, int *twid)
 	     mt->mt_readlink,
 	     mt->mt_statfs,
 
-	     tp->tm_year > 99 ? tp->tm_year - 100 : tp->tm_year,
 	     tp->tm_mon + 1, tp->tm_mday,
+	     tp->tm_year < 1900 ? tp->tm_year + 1900 : tp->tm_year,
 	     tp->tm_hour, tp->tm_min, tp->tm_sec);
     }
   break;
@@ -186,6 +162,31 @@ show_mti(amq_mount_tree *mt, enum show_opt e, int *mwid, int *dwid, int *twid)
   }
 }
 
+
+/*
+ * Display a pwd data
+ */
+static void
+show_pwd(amq_mount_tree *mt, char *path, size_t l, int *flag)
+{
+  int len;
+
+  while (mt) {
+    len = strlen(mt->mt_mountpoint);
+    if (NSTREQ(path, mt->mt_mountpoint, len) &&
+	!STREQ(mt->mt_directory, mt->mt_mountpoint)) {
+      char buf[MAXPATHLEN+1];	/* must be same size as 'path' */
+      xstrlcpy(buf, mt->mt_directory, sizeof(buf));
+      xstrlcat(buf, &path[len], sizeof(buf));
+      xstrlcpy(path, buf, l);
+      *flag = 1;
+    }
+    show_pwd(mt->mt_next, path, l, flag);
+    mt = mt->mt_child;
+  }
+}
+
+
 /*
  * Display a mount tree.
  */
@@ -199,10 +200,11 @@ show_mt(amq_mount_tree *mt, enum show_opt e, int *mwid, int *dwid, int *pwid)
   }
 }
 
+
 static void
 show_mi(amq_mount_info_list *ml, enum show_opt e, int *mwid, int *dwid, int *twid)
 {
-  int i;
+  u_int i;
 
   switch (e) {
 
@@ -235,14 +237,7 @@ show_mi(amq_mount_info_list *ml, enum show_opt e, int *mwid, int *dwid, int *twi
 	       mi->mi_up > 0 ? "up" :
 	       mi->mi_up < 0 ? "starting" : "down");
 	if (mi->mi_error > 0) {
-	  if (mi->mi_error < sys_nerr)
-#ifdef HAVE_STRERROR
-	    printf(" (%s)", strerror(mi->mi_error));
-#else /* not HAVE_STRERROR */
-	    printf(" (%s)", sys_errlist[mi->mi_error]);
-#endif /* not HAVE_STRERROR */
-	  else
-	    printf(" (Error %d)", mi->mi_error);
+	  printf(" (%s)", strerror(mi->mi_error));
 	} else if (mi->mi_error < 0) {
 	  fputs(" (in progress)", stdout);
 	}
@@ -302,16 +297,11 @@ main(int argc, char *argv[])
   int errs = 0;
   char *server;
   struct sockaddr_in server_addr;
-  int s;	/* to pass the Amd security check, we must use a priv port */
   CLIENT *clnt = NULL;
   struct hostent *hp;
   int nodefault = 0;
   struct timeval tv;
   char *progname = NULL;
-#ifndef HAVE_TRANSPORT_TYPE_TLI
-  enum clnt_stat cs;
-#endif /* not HAVE_TRANSPORT_TYPE_TLI */
-
 
   /*
    * Compute program name
@@ -330,12 +320,12 @@ main(int argc, char *argv[])
   /*
    * Parse arguments
    */
-#ifdef ENABLE_AMQ_MOUNT
-  while ((opt_ch = getopt(argc, argv, "fh:l:msuvx:D:M:pP:TU")) != -1)
-#else /* not ENABLE_AMQ_MOUNT */
-  while ((opt_ch = getopt(argc, argv, "fh:l:msuvx:D:pP:TU")) != -1)
-#endif /* not ENABLE_AMQ_MOUNT */
+  while ((opt_ch = getopt(argc, argv, "Hfh:l:msuvx:D:pP:TUw")) != -1)
     switch (opt_ch) {
+    case 'H':
+      goto show_usage;
+      break;
+
     case 'f':
       flush_flag = 1;
       nodefault = 1;
@@ -385,13 +375,6 @@ main(int argc, char *argv[])
       nodefault = 1;
       break;
 
-#ifdef ENABLE_AMQ_MOUNT
-    case 'M':
-      mount_map = optarg;
-      nodefault = 1;
-      break;
-#endif /* ENABLE_AMQ_MOUNT */
-
     case 'P':
       amd_program_number = atoi(optarg);
       break;
@@ -404,6 +387,10 @@ main(int argc, char *argv[])
       use_udp_flag = 1;
       break;
 
+    case 'w':
+      getpwd_flag = 1;
+      break;
+
     default:
       errs = 1;
       break;
@@ -416,21 +403,15 @@ main(int argc, char *argv[])
   if (errs) {
   show_usage:
     fprintf(stderr, "\
-Usage: %s [-h host] [[-f] [-m] [-p] [-v] [-s]] | [[-u] directory ...]]\n\
-\t[-l logfile|\"syslog\"] [-x log_flags] [-D dbg_opts]%s\n\
-\t[-P prognum] [-T] [-U]\n",
-	    am_get_progname(),
-#ifdef ENABLE_AMQ_MOUNT
-	    " [-M mapent]"
-#else /* not ENABLE_AMQ_MOUNT */
-	    ""
-#endif /* not ENABLE_AMQ_MOUNT */
+Usage: %s [-fmpsvwHTU] [-h hostname] [-l log_file|\"syslog\"]\n\
+\t[-x log_options] [-D debug_options]\n\
+\t[-P program_number] [[-u] directory ...]\n",
+	    am_get_progname()
     );
     exit(1);
   }
 
 
-
   /* set use_udp and use_tcp flags both to on if none are defined */
   if (!use_tcp_flag && !use_udp_flag)
     use_tcp_flag = use_udp_flag = 1;
@@ -453,7 +434,8 @@ Usage: %s [-h host] [[-f] [-m] [-p] [-v] [-s]] | [[-u] directory ...]]\n\
 	    am_get_progname(), server);
     exit(1);
   }
-  memset(&server_addr, 0, sizeof server_addr);
+  memset(&server_addr, 0, sizeof(server_addr));
+  /* as per POSIX, sin_len need not be set (used internally by kernel) */
   server_addr.sin_family = AF_INET;
   if (hp) {
     memmove((voidp) &server_addr.sin_addr, (voidp) hp->h_addr,
@@ -469,9 +451,7 @@ Usage: %s [-h host] [[-f] [-m] [-p] [-v] [-s]] | [[-u] directory ...]]\n\
   tv.tv_sec = 5;		/* 5 seconds for timeout or per retry */
   tv.tv_usec = 0;
 
-#ifdef HAVE_TRANSPORT_TYPE_TLI
-  clnt = get_secure_amd_client(server, &tv, &s);
-  if (!clnt && use_tcp_flag)	/* try tcp first */
+  if (use_tcp_flag)	/* try tcp first */
     clnt = clnt_create(server, amd_program_number, AMQ_VERSION, "tcp");
   if (!clnt && use_udp_flag) {	/* try udp next */
     clnt = clnt_create(server, amd_program_number, AMQ_VERSION, "udp");
@@ -479,29 +459,6 @@ Usage: %s [-h host] [[-f] [-m] [-p] [-v] [-s]] | [[-u] directory ...]]\n\
     if (clnt)
       clnt_control(clnt, CLSET_RETRY_TIMEOUT, (char *) &tv);
   }
-#else /* not HAVE_TRANSPORT_TYPE_TLI */
-
-  /* first check if remote portmapper is up */
-  cs = pmap_ping(&server_addr);
-  if (cs == RPC_TIMEDOUT) {
-    fprintf(stderr, "%s: failed to contact portmapper on host \"%s\". %s\n",
-	    am_get_progname(), server, clnt_sperrno(cs));
-    exit(1);
-  }
-
-  /* portmapper exists: get remote amd info from it */
-  if (!clnt && use_tcp_flag) {	/* try tcp first */
-    s = RPC_ANYSOCK;
-    clnt = clnttcp_create(&server_addr, amd_program_number,
-			  AMQ_VERSION, &s, 0, 0);
-  }
-  if (!clnt && use_udp_flag) {	/* try udp next */
-    /* XXX: do we need to close(s) ? */
-    s = privsock(SOCK_DGRAM);
-    clnt = clntudp_create(&server_addr, amd_program_number,
-			  AMQ_VERSION, tv, &s);
-  }
-#endif /* not HAVE_TRANSPORT_TYPE_TLI */
   if (!clnt) {
     fprintf(stderr, "%s: ", am_get_progname());
     clnt_pcreateerror(server);
@@ -577,6 +534,35 @@ Usage: %s [-h host] [[-f] [-m] [-p] [-v] [-s]] | [[-u] directory ...]]\n\
   }
 
   /*
+   * getpwd info
+   */
+  if (getpwd_flag) {
+    char path[MAXPATHLEN+1];
+    char *wd = getcwd(path, MAXPATHLEN+1);
+    amq_mount_tree_list *mlp = amqproc_export_1((voidp) 0, clnt);
+    amq_mount_tree_p mt;
+    u_int i;
+    int flag;
+
+    if (!wd) {
+      perror("getcwd");
+      exit(1);
+    }
+    for (i = 0; mlp && i < mlp->amq_mount_tree_list_len; i++) {
+      mt = mlp->amq_mount_tree_list_val[i];
+      while (1) {
+	flag = 0;
+	show_pwd(mt, path, sizeof(path), &flag);
+	if (!flag) {
+	  printf("%s\n", path);
+	  break;
+	}
+      }
+    }
+    exit(0);
+  }
+
+  /*
    * Mount info
    */
   if (minfo_flag) {
@@ -597,24 +583,6 @@ Usage: %s [-h host] [[-f] [-m] [-p] [-v] [-s]] | [[-u] directory ...]]\n\
   }
 
   /*
-   * Mount map
-   */
-  if (mount_map) {
-    int *rc;
-    do {
-      rc = amqproc_mount_1(&mount_map, clnt);
-    } while (rc && *rc < 0);
-    if (!rc || *rc > 0) {
-      if (rc)
-	errno = *rc;
-      else
-	errno = ETIMEDOUT;
-      fprintf(stderr, "%s: could not start new ", am_get_progname());
-      perror("automount point");
-    }
-  }
-
-  /*
    * Get Version
    */
   if (getvers_flag) {
@@ -698,8 +666,9 @@ Usage: %s [-h host] [[-f] [-m] [-p] [-v] [-s]] | [[-u] directory ...]]\n\
     if (mlp) {
       enum show_opt e = Calc;
       int mwid = 0, dwid = 0, pwid = 0;
+
       while (e != ShowDone) {
-	int i;
+	u_int i;
 	for (i = 0; i < mlp->amq_mount_tree_list_len; i++) {
 	  show_mt(mlp->amq_mount_tree_list_val[i],
 		  e, &mwid, &dwid, &pwid);
@@ -721,241 +690,3 @@ Usage: %s [-h host] [[-f] [-m] [-p] [-v] [-s]] | [[-u] directory ...]]\n\
   exit(errs);
   return errs; /* should never reach here */
 }
-
-
-#ifdef HAVE_TRANSPORT_TYPE_TLI
-
-/*
- * How to bind to reserved ports.
- * TLI handle (socket) and port version.
- */
-/* defined here so that it does not have to resolve it with libamu.a */
-static int
-amq_bind_resv_port(int td, u_short *pp)
-{
-  int rc = -1, port;
-  struct t_bind *treq, *tret;
-  struct sockaddr_in *sin;
-
-  treq = (struct t_bind *) t_alloc(td, T_BIND, T_ADDR);
-  if (!treq) {
-    plog(XLOG_ERROR, "t_alloc 1");
-    return -1;
-  }
-  tret = (struct t_bind *) t_alloc(td, T_BIND, T_ADDR);
-  if (!tret) {
-    t_free((char *) treq, T_BIND);
-    plog(XLOG_ERROR, "t_alloc 2");
-    return -1;
-  }
-  memset((char *) treq->addr.buf, 0, treq->addr.len);
-  sin = (struct sockaddr_in *) treq->addr.buf;
-  sin->sin_family = AF_INET;
-  treq->qlen = 0;
-  treq->addr.len = treq->addr.maxlen;
-  errno = EADDRINUSE;
-  port = IPPORT_RESERVED;
-
-  do {
-    --port;
-    sin->sin_port = htons(port);
-    rc = t_bind(td, treq, tret);
-    if (rc < 0) {
-    } else {
-      if (memcmp(treq->addr.buf, tret->addr.buf, tret->addr.len) == 0)
-	break;
-      else
-	t_unbind(td);
-    }
-  } while ((rc < 0 || errno == EADDRINUSE) && (int) port > IPPORT_RESERVED / 2);
-
-  if (pp) {
-    if (rc == 0)
-      *pp = port;
-    else
-      plog(XLOG_ERROR, "could not t_bind to any reserved port");
-  }
-  t_free((char *) tret, T_BIND);
-  t_free((char *) treq, T_BIND);
-  return rc;
-}
-
-
-/*
- * Create a secure rpc client attached to the amd daemon.
- */
-static CLIENT *
-get_secure_amd_client(char *host, struct timeval *tv, int *sock)
-{
-  CLIENT *client;
-  struct netbuf nb;
-  struct netconfig *nc, *pm_nc;
-  struct sockaddr_in sin;
-
-
-  nb.maxlen = sizeof(sin);
-  nb.buf = (char *) &sin;
-
-  /*
-   * Ensure that remote portmapper is alive
-   * (must use connectionless netconfig).
-   */
-  if ((pm_nc = getnetconfigent(NC_UDP)) != NULL) {
-    enum clnt_stat cs;
-
-    cs = rpcb_rmtcall(pm_nc,
-		      host,
-		      amd_program_number,
-		      AMQ_VERSION,
-		      AMQPROC_NULL,
-		      (XDRPROC_T_TYPE) xdr_void,
-		      NULL,
-		      (XDRPROC_T_TYPE) xdr_void,
-		      NULL,
-		      *tv,
-		      NULL);
-    if (cs == RPC_TIMEDOUT) {
-      fprintf(stderr, "%s: failed to contact portmapper on host \"%s\". %s\n",
-	      am_get_progname(), host, clnt_sperrno(cs));
-      exit(1);
-    }
-  }
-
-  /*
-   * First transport type to try: TCP
-   */
-  if (use_tcp_flag) {
-    /* Find amd address on TCP */
-    nc = getnetconfigent(NC_TCP);
-    if (!nc) {
-      fprintf(stderr, "getnetconfig for tcp failed: %s\n", nc_sperror());
-      goto tryudp;
-    }
-
-    if (!rpcb_getaddr(amd_program_number, AMQ_VERSION, nc, &nb, host)) {
-      /*
-       * don't print error messages here, since amd might legitimately
-       * serve udp only
-       */
-      goto tryudp;
-    }
-    /* Create privileged TCP socket */
-    *sock = t_open(nc->nc_device, O_RDWR, 0);
-
-    if (*sock < 0) {
-      fprintf(stderr, "t_open %s: %m\n", nc->nc_device);
-      goto tryudp;
-    }
-    if (amq_bind_resv_port(*sock, (u_short *) 0) < 0)
-      goto tryudp;
-
-    client = clnt_vc_create(*sock, &nb, amd_program_number, AMQ_VERSION, 0, 0);
-    if (!client) {
-      fprintf(stderr, "clnt_vc_create failed");
-      t_close(*sock);
-      goto tryudp;
-    }
-    /* tcp succeeded */
-    return client;
-  }
-
-tryudp:
-  /*
-   * TCP failed so try UDP
-   */
-  if (use_udp_flag) {
-    /* find amd address on UDP */
-    nc = getnetconfigent(NC_UDP);
-    if (!nc) {
-      fprintf(stderr, "getnetconfig for udp failed: %s\n", nc_sperror());
-      return NULL;
-    }
-    if (!rpcb_getaddr(amd_program_number, AMQ_VERSION, nc, &nb, host)) {
-      fprintf(stderr, "%s\n",
-	      clnt_spcreateerror("couldn't get amd address on udp"));
-      return NULL;
-    }
-    /* create privileged UDP socket */
-    *sock = t_open(nc->nc_device, O_RDWR, 0);
-
-    if (*sock < 0) {
-      fprintf(stderr, "t_open %s: %m\n", nc->nc_device);
-      return NULL;		/* neither tcp not udp succeeded */
-    }
-    if (amq_bind_resv_port(*sock, (u_short *) 0) < 0)
-      return NULL;
-
-    client = clnt_dg_create(*sock, &nb, amd_program_number, AMQ_VERSION, 0, 0);
-    if (!client) {
-      fprintf(stderr, "clnt_dg_create failed\n");
-      t_close(*sock);
-      return NULL;		/* neither tcp not udp succeeded */
-    }
-    if (clnt_control(client, CLSET_RETRY_TIMEOUT, (char *) tv) == FALSE) {
-      fprintf(stderr, "clnt_control CLSET_RETRY_TIMEOUT for udp failed\n");
-      clnt_destroy(client);
-      return NULL;		/* neither tcp not udp succeeded */
-    }
-    /* udp succeeded */
-    return client;
-  }
-
-  /* should never get here */
-  return NULL;
-}
-
-#else /* not HAVE_TRANSPORT_TYPE_TLI */
-
-/*
- * inetresport creates a datagram socket and attempts to bind it to a
- * secure port.
- * returns: The bound socket, or -1 to indicate an error.
- */
-static int
-inetresport(int ty)
-{
-  int alport;
-  struct sockaddr_in addr;
-  int fd;
-
-  /* Use internet address family */
-  addr.sin_family = AF_INET;
-  addr.sin_addr.s_addr = INADDR_ANY;
-  if ((fd = socket(AF_INET, ty, 0)) < 0)
-    return -1;
-
-  for (alport = IPPORT_RESERVED - 1; alport > IPPORT_RESERVED / 2 + 1; alport--) {
-    addr.sin_port = htons((u_short) alport);
-    if (bind(fd, (struct sockaddr *) &addr, sizeof(addr)) >= 0)
-      return fd;
-    if (errno != EADDRINUSE) {
-      close(fd);
-      return -1;
-    }
-  }
-  close(fd);
-  errno = EAGAIN;
-  return -1;
-}
-
-
-/*
- * Privsock() calls inetresport() to attempt to bind a socket to a secure
- * port.  If inetresport() fails, privsock returns a magic socket number which
- * indicates to RPC that it should make its own socket.
- * returns: A privileged socket # or RPC_ANYSOCK.
- */
-static int
-privsock(int ty)
-{
-  int sock = inetresport(ty);
-
-  if (sock < 0) {
-    errno = 0;
-    /* Couldn't get a secure port, let RPC make an insecure one */
-    sock = RPC_ANYSOCK;
-  }
-  return sock;
-}
-
-#endif /* not HAVE_TRANSPORT_TYPE_TLI */
diff --git a/contrib/amd/amq/amq.h b/contrib/amd/amq/amq.h
index cebe624..2f36b81 100644
--- a/contrib/amd/amq/amq.h
+++ b/contrib/amd/amq/amq.h
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: amq.h,v 1.2 1999/01/10 21:53:59 ezk Exp $
+ * File: am-utils/amq/amq.h
  *
  */
 
@@ -59,5 +58,6 @@ extern amq_mount_info_list *amqproc_getmntfs_1(voidp argp, CLIENT *rqstp);
 extern int *amqproc_mount_1(voidp argp, CLIENT *rqstp);
 extern amq_string *amqproc_getvers_1(voidp argp, CLIENT *rqstp);
 extern int *amqproc_getpid_1(voidp argp, CLIENT *rqstp);
+extern amq_string *amqproc_pawd_1(amq_string *argp, CLIENT *rqstp);
 
 #endif /* not _AMQ_H */
diff --git a/contrib/amd/amq/amq_clnt.c b/contrib/amd/amq/amq_clnt.c
index 1251c87..ddfeb67 100644
--- a/contrib/amd/amq/amq_clnt.c
+++ b/contrib/amd/amq/amq_clnt.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: amq_clnt.c,v 1.2 1999/01/10 21:53:59 ezk Exp $
+ * File: am-utils/amq/amq_clnt.c
  *
  */
 
@@ -76,7 +75,7 @@ amqproc_mnttree_1(amq_string *argp, CLIENT *clnt)
   memset((char *) &res, 0, sizeof(res));
   if (clnt_call(clnt, AMQPROC_MNTTREE,
 		(XDRPROC_T_TYPE) xdr_amq_string, (SVC_IN_ARG_TYPE) argp,
-		(XDRPROC_T_TYPE) xdr_amq_mount_tree_p, (SVC_IN_ARG_TYPE) & res,
+		(XDRPROC_T_TYPE) xdr_amq_mount_tree_p, (SVC_IN_ARG_TYPE) &res,
 		TIMEOUT) != RPC_SUCCESS) {
     return (NULL);
   }
@@ -109,7 +108,7 @@ amqproc_stats_1(voidp argp, CLIENT *clnt)
   if (clnt_call(clnt, AMQPROC_STATS,
 		(XDRPROC_T_TYPE) xdr_void, argp,
 		(XDRPROC_T_TYPE) xdr_amq_mount_stats,
-		(SVC_IN_ARG_TYPE) & res,
+		(SVC_IN_ARG_TYPE) &res,
 		TIMEOUT) != RPC_SUCCESS) {
     return (NULL);
   }
@@ -126,7 +125,7 @@ amqproc_export_1(voidp argp, CLIENT *clnt)
   if (clnt_call(clnt, AMQPROC_EXPORT,
 		(XDRPROC_T_TYPE) xdr_void, argp,
 		(XDRPROC_T_TYPE) xdr_amq_mount_tree_list,
-		(SVC_IN_ARG_TYPE) & res, TIMEOUT) != RPC_SUCCESS) {
+		(SVC_IN_ARG_TYPE) &res, TIMEOUT) != RPC_SUCCESS) {
     return (NULL);
   }
   return (&res);
@@ -141,7 +140,7 @@ amqproc_setopt_1(amq_setopt *argp, CLIENT *clnt)
   memset((char *) &res, 0, sizeof(res));
   if (clnt_call(clnt, AMQPROC_SETOPT, (XDRPROC_T_TYPE) xdr_amq_setopt,
 		(SVC_IN_ARG_TYPE) argp, (XDRPROC_T_TYPE) xdr_int,
-		(SVC_IN_ARG_TYPE) & res, TIMEOUT) != RPC_SUCCESS) {
+		(SVC_IN_ARG_TYPE) &res, TIMEOUT) != RPC_SUCCESS) {
     return (NULL);
   }
   return (&res);
@@ -156,7 +155,7 @@ amqproc_getmntfs_1(voidp argp, CLIENT *clnt)
   memset((char *) &res, 0, sizeof(res));
   if (clnt_call(clnt, AMQPROC_GETMNTFS, (XDRPROC_T_TYPE) xdr_void, argp,
 		(XDRPROC_T_TYPE) xdr_amq_mount_info_list,
-		(SVC_IN_ARG_TYPE) & res, TIMEOUT) != RPC_SUCCESS) {
+		(SVC_IN_ARG_TYPE) &res, TIMEOUT) != RPC_SUCCESS) {
     return (NULL);
   }
   return (&res);
@@ -170,7 +169,7 @@ amqproc_mount_1(voidp argp, CLIENT *clnt)
 
   memset((char *) &res, 0, sizeof(res));
   if (clnt_call(clnt, AMQPROC_MOUNT, (XDRPROC_T_TYPE) xdr_amq_string, argp,
-		(XDRPROC_T_TYPE) xdr_int, (SVC_IN_ARG_TYPE) & res,
+		(XDRPROC_T_TYPE) xdr_int, (SVC_IN_ARG_TYPE) &res,
 		TIMEOUT) != RPC_SUCCESS) {
     return (NULL);
   }
@@ -185,7 +184,7 @@ amqproc_getvers_1(voidp argp, CLIENT *clnt)
 
   memset((char *) &res, 0, sizeof(res));
   if (clnt_call(clnt, AMQPROC_GETVERS, (XDRPROC_T_TYPE) xdr_void, argp,
-		(XDRPROC_T_TYPE) xdr_amq_string, (SVC_IN_ARG_TYPE) & res,
+		(XDRPROC_T_TYPE) xdr_amq_string, (SVC_IN_ARG_TYPE) &res,
 		TIMEOUT) != RPC_SUCCESS) {
     return (NULL);
   }
@@ -200,7 +199,23 @@ amqproc_getpid_1(voidp argp, CLIENT *clnt)
 
   memset((char *) &res, 0, sizeof(res));
   if (clnt_call(clnt, AMQPROC_GETPID, (XDRPROC_T_TYPE) xdr_void, argp,
-		(XDRPROC_T_TYPE) xdr_int, (SVC_IN_ARG_TYPE) & res,
+		(XDRPROC_T_TYPE) xdr_int, (SVC_IN_ARG_TYPE) &res,
+		TIMEOUT) != RPC_SUCCESS) {
+    return (NULL);
+  }
+  return (&res);
+}
+
+
+amq_string *
+amqproc_pawd_1(amq_string *argp, CLIENT *clnt)
+{
+  static amq_string res;
+
+  memset((char *) &res, 0, sizeof(res));
+  if (clnt_call(clnt, AMQPROC_PAWD,
+		(XDRPROC_T_TYPE) xdr_amq_string, (SVC_IN_ARG_TYPE) argp,
+		(XDRPROC_T_TYPE) xdr_amq_string, (SVC_IN_ARG_TYPE) &res,
 		TIMEOUT) != RPC_SUCCESS) {
     return (NULL);
   }
diff --git a/contrib/amd/amq/amq_xdr.c b/contrib/amd/amq/amq_xdr.c
index 26b93b3..692a0a4 100644
--- a/contrib/amd/amq/amq_xdr.c
+++ b/contrib/amd/amq/amq_xdr.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: amq_xdr.c,v 1.2 1999/01/10 21:53:59 ezk Exp $
+ * File: am-utils/amq/amq_xdr.c
  *
  */
 
@@ -107,11 +106,17 @@ xdr_amq_mount_tree(XDR *xdrs, amq_mount_tree *objp)
     return (FALSE);
   }
 
-  if (!xdr_pointer(xdrs, (char **) &objp->mt_next, sizeof(amq_mount_tree), (XDRPROC_T_TYPE) xdr_amq_mount_tree)) {
+  if (!xdr_pointer(xdrs,
+		   (char **) ((voidp) &objp->mt_next),
+		   sizeof(amq_mount_tree),
+		   (XDRPROC_T_TYPE) xdr_amq_mount_tree)) {
     return (FALSE);
   }
 
-  if (!xdr_pointer(xdrs, (char **) &objp->mt_child, sizeof(amq_mount_tree), (XDRPROC_T_TYPE) xdr_amq_mount_tree)) {
+  if (!xdr_pointer(xdrs,
+		   (char **) ((voidp) &objp->mt_child),
+		   sizeof(amq_mount_tree),
+		   (XDRPROC_T_TYPE) xdr_amq_mount_tree)) {
     return (FALSE);
   }
 
@@ -122,7 +127,10 @@ xdr_amq_mount_tree(XDR *xdrs, amq_mount_tree *objp)
 bool_t
 xdr_amq_mount_tree_p(XDR *xdrs, amq_mount_tree_p *objp)
 {
-  if (!xdr_pointer(xdrs, (char **) objp, sizeof(amq_mount_tree), (XDRPROC_T_TYPE) xdr_amq_mount_tree)) {
+  if (!xdr_pointer(xdrs,
+		   (char **) objp,
+		   sizeof(amq_mount_tree),
+		   (XDRPROC_T_TYPE) xdr_amq_mount_tree)) {
     return (FALSE);
   }
   return (TRUE);
@@ -169,7 +177,7 @@ bool_t
 xdr_amq_mount_info_list(XDR *xdrs, amq_mount_info_list *objp)
 {
   if (!xdr_array(xdrs,
-		 (char **) &objp->amq_mount_info_list_val,
+		 (char **) ((voidp) &objp->amq_mount_info_list_val),
 		 (u_int *) &objp->amq_mount_info_list_len,
 		 ~0,
 		 sizeof(amq_mount_info),
@@ -184,7 +192,7 @@ bool_t
 xdr_amq_mount_tree_list(XDR *xdrs, amq_mount_tree_list *objp)
 {
   if (!xdr_array(xdrs,
-		 (char **) &objp->amq_mount_tree_list_val,
+		 (char **) ((voidp) &objp->amq_mount_tree_list_val),
 		 (u_int *) &objp->amq_mount_tree_list_len,
 		 ~0,
 		 sizeof(amq_mount_tree_p),
diff --git a/contrib/amd/amq/pawd.c b/contrib/amd/amq/pawd.c
index cf9dce6..c9a32b1 100644
--- a/contrib/amd/amq/pawd.c
+++ b/contrib/amd/amq/pawd.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: pawd.c,v 1.5 1999/09/08 23:36:40 ezk Exp $
+ * File: am-utils/amq/pawd.c
  *
  */
 
@@ -58,48 +57,11 @@
 #include <am_defs.h>
 #include <amq.h>
 
+
 /* statics */
-static char *localhost="localhost";
-static char newdir[MAXPATHLEN];
+static char *localhost = "localhost";
 static char transform[MAXPATHLEN];
 
-static int
-find_mt(amq_mount_tree *mt, char *dir)
-{
-  while (mt) {
-    if (STREQ(mt->mt_type, "link") ||
-	STREQ(mt->mt_type, "nfs") ||
-	STREQ(mt->mt_type, "nfsl")) {
-      int len = strlen(mt->mt_mountpoint);
-      if (NSTREQ(mt->mt_mountpoint, dir, len) &&
-	  ((dir[len] == '\0') || (dir[len] == '/'))) {
-	char tmp_buf[MAXPATHLEN];
-	strcpy(tmp_buf, mt->mt_directory);
-	strcat(tmp_buf, &dir[len]);
-	strcpy(newdir, tmp_buf);
-	return 1;
-      }
-    }
-    if (find_mt(mt->mt_next,dir))
-      return 1;
-    mt = mt->mt_child;
-  }
-  return 0;
-}
-
-
-static int
-find_mlp(amq_mount_tree_list *mlp, char *dir)
-{
-  int i;
-
-  for (i = 0; i < mlp->amq_mount_tree_list_len; i++) {
-    if (find_mt(mlp->amq_mount_tree_list_val[i], dir))
-      return 1;
-  }
-  return 0;
-}
-
 
 #ifdef HAVE_CNODEID
 static char *
@@ -160,7 +122,8 @@ hack_name(char *dir)
     fprintf(stderr, "partition %s, username %s\n", partition, username);
 #endif /* DEBUG */
 
-    sprintf(hesiod_lookup, "%s.homes-remote", username);
+    xsnprintf(hesiod_lookup, sizeof(hesiod_lookup),
+	      "%s.homes-remote", username);
     hes = hes_resolve(hesiod_lookup, "amd");
     if (!hes)
       return NULL;
@@ -184,9 +147,10 @@ hack_name(char *dir)
 #ifdef DEBUG
     fprintf(stderr, "A match, munging....\n");
 #endif /* DEBUG */
-    strcpy(transform, "/home/");
-    strcat(transform, username);
-    if (*ch) strcat(transform, ch);
+    xstrlcpy(transform, "/home/", sizeof(transform));
+    xstrlcat(transform, username, sizeof(transform));
+    if (*ch)
+      xstrlcat(transform, ch, sizeof(transform));
 #ifdef DEBUG
     fprintf(stderr, "Munged to <%s>\n", transform);
 #endif /* DEBUG */
@@ -216,8 +180,9 @@ transform_dir(char *dir)
   int s = RPC_ANYSOCK;
   CLIENT *clnt;
   struct hostent *hp;
-  amq_mount_tree_list *mlp;
   struct timeval tmo = {10, 0};
+  char *dummystr;
+  amq_string *spp;
 
 #ifdef DISK_HOME_HACK
   if (ch = hack_name(dir))
@@ -230,31 +195,37 @@ transform_dir(char *dir)
   server = localhost;
 #endif /* not HAVE_CNODEID */
 
-  if ((hp = gethostbyname(server)) == 0)
+  if ((hp = gethostbyname(server)) == NULL)
     return dir;
   memset(&server_addr, 0, sizeof(server_addr));
+  /* as per POSIX, sin_len need not be set (used internally by kernel) */
   server_addr.sin_family = AF_INET;
   server_addr.sin_addr = *(struct in_addr *) hp->h_addr;
 
   clnt = clntudp_create(&server_addr, AMQ_PROGRAM, AMQ_VERSION, tmo, &s);
-  if (clnt == 0)
+  if (clnt == NULL)
+    clnt = clnttcp_create(&server_addr, AMQ_PROGRAM, AMQ_VERSION, &s, 0, 0);
+  if (clnt == NULL)
     return dir;
 
-  strcpy(transform,dir);
-  while ( (mlp = amqproc_export_1((voidp)0, clnt)) &&
-	  find_mlp(mlp,transform) ) {
-    strcpy(transform,newdir);
+  xstrlcpy(transform, dir, sizeof(transform));
+  dummystr = transform;
+  spp = amqproc_pawd_1((amq_string *) &dummystr, clnt);
+  if (spp && *spp && **spp) {
+    xstrlcpy(transform, *spp, sizeof(transform));
+    XFREE(*spp);
   }
+  clnt_destroy(clnt);
   return transform;
 }
 
 
 /* getawd() is a substitute for getwd() which transforms the path */
 static char *
-getawd(char *path)
+getawd(char *path, size_t l)
 {
 #ifdef HAVE_GETCWD
-  char *wd = getcwd(path, MAXPATHLEN+1);
+  char *wd = getcwd(path, MAXPATHLEN);
 #else /* not HAVE_GETCWD */
   char *wd = getwd(path);
 #endif /* not HAVE_GETCWD */
@@ -262,7 +233,7 @@ getawd(char *path)
   if (wd == NULL) {
     return NULL;
   }
-  strcpy(path, transform_dir(wd));
+  xstrlcpy(path, transform_dir(wd), l);
   return path;
 }
 
@@ -273,7 +244,7 @@ main(int argc, char *argv[])
   char tmp_buf[MAXPATHLEN], *wd;
 
   if (argc == 1) {
-    wd = getawd(tmp_buf);
+    wd = getawd(tmp_buf, sizeof(tmp_buf));
     if (wd == NULL) {
       fprintf(stderr, "pawd: %s\n", tmp_buf);
       exit(1);
